﻿using Braintree;
using CMS.EcommerceProvider;
using CMS.EventLog;
using CMS.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class BraintreePaymentForm : CMSPaymentGatewayForm
{
    public string strClientToken = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Initialize label     
            lblTitle.Text = "Your credit card details";
            lblCardName.Text = "Name on card";
            lblCardNumber.Text = "Card Number";
            lblExpDate.Text = "Exp Date";
            lblCVV2.Text = "CVV2";
        }
        catch(Exception ex)
        {
            EventLogProvider.LogException("BraintreePaymentForm", "EXCEPTION", ex);
            lblError.Text = "There was an error connecting to the payment processor. Please try again.";
            phForm.Visible = false;
        }
    }

    /// <summary>
    /// Initializes form controls with customer payment data.
    /// </summary>
    public override void LoadData()
    {
        // Display customer credit card number
        txtCardNumber.Text = ValidationHelper.GetString(PaymentGatewayCustomData["CustomGatewayCardNumber"], "");
    }

    /// <summary>
    /// Validates customer payment data.
    /// </summary>
    /// <returns></returns>
    public override string ValidateData()
    {
        if (txtCardNumber.Text.Trim() == "")
        {
            lblError.Visible = true;
            lblError.Text = "Please enter your credit card number";
            return lblError.Text;
        }
        return "";
    }

    /// <summary>
    /// Process customer payment data.
    /// </summary>
    /// <returns></returns>
    public override string ProcessData()
    {

        // Save credit card number
        PaymentGatewayCustomData["CardName"] = txtCardNumber.Text.Trim();
        PaymentGatewayCustomData["CardNumber"] = txtCardNumber.Text.Trim();
        PaymentGatewayCustomData["CVV2"] = txtCVV2.Text;
        PaymentGatewayCustomData["ExpMonth"] = txtExpDateMonth.Text;
        PaymentGatewayCustomData["ExpYear"] = txtExpDateYear.Text;
        return "";
    }
}